Go to the latest version of this document.

# ``twisted`.`trial`.`reporter`.`TreeReporter``

class documentation

`class TreeReporter(Reporter): (source)`

Constructor: `TreeReporter(stream, *args, **kwargs)`

View In Hierarchy

Print out the tests in the form a tree.

Tests are indented according to which class and module they belong. Results are printed in ANSI color.

Method | `__init__` | Undocumented
Method | `addError` | Called when a test raises an error. If `realtime` is set, then it prints the error to the stream.
Method | `addExpectedFailure` | Report that the given test failed, and was expected to do so.
Method | `addFailure` | Called when a test fails. If `realtime` is set, then it prints the error to the stream.
Method | `addSkip` | Report that the given test was skipped.
Method | `addSuccess` | Report that the given test succeeded.
Method | `addUnexpectedSuccess` | Report that the given test succeeded against expectations.
Method | `cleanupErrors` | Undocumented
Method | `endLine` | Print 'message' in the given color.
Method | `getDescription` | Return the name of the method which 'test' represents. This is what gets displayed in the leaves of the tree.
Method | `startTest` | Called when `test` starts. Writes the tests name to the stream using a tree format.
Method | `upDownError` | Undocumented
Constant | `ERROR` | Undocumented
Constant | `FAILURE` | Undocumented
Constant | `SKIP` | Undocumented
Constant | `SUCCESS` | Undocumented
Constant | `TODO` | Undocumented
Constant | `TODONE` | Undocumented
Class Variable | `columns` | Undocumented
Class Variable | `indent` | Undocumented
Instance Variable | `currentLine` | Undocumented
Method | `_getPreludeSegments` | Return a list of all non-leaf segments to display in the tree.
Method | `_printSummary` | Print a line summarising the test results to the stream, and color the status result.
Method | `_testPrelude` | Write the name of the test to the stream, indenting it appropriately.
Method | `_write` | Safely write to the reporter's stream.
Instance Variable | `_colorizer` | Undocumented
Instance Variable | `_lastTest` | Undocumented

Inherited from `Reporter`:

Method | `done` | Summarize the result of the test run.
Instance Variable | `realtime` | Undocumented
Instance Variable | `tbformat` | Undocumented
Method | `_formatFailureTraceback` | Undocumented
Method | `_getSummary` | Return a formatted count of tests status results.
Method | `_groupResults` | Group tests together based on their results.
Method | `_observeWarnings` | Observe warning events and write them to `self._stream`.
Method | `_printErrors` | Print all of the non-success results to the stream in full.
Method | `_printExpectedFailure` | Undocumented
Method | `_printResults` | Print a group of errors to the stream.
Method | `_printUnexpectedSuccess` | Undocumented
Method | `_trimFrames` | Trim frames to remove internal paths.
Method | `_writeln` | Safely write a line to the reporter's stream. Newline is appended to the format string.
Class Variable | `_doubleSeparator` | Undocumented
Class Variable | `_separator` | Undocumented
Instance Variable | `_publisher` | The log publisher which will be observed for warning events.
Instance Variable | `_startTime` | The time when the first test was started. It defaults to `None`, which means that no test was actually launched.
Instance Variable | `_stream` | Undocumented
Instance Variable | `_warningCache` | A `set` of tuples of warning message (file, line, text, category) which have already been written to the output stream during the currently executing test. This is used to avoid writing duplicates of the same warning to the output stream.

Inherited from `TestResult` (via `Reporter`):

Method | `__repr__` | Undocumented
Method | `stopTest` | This must be called after the given test is completed.
Method | `wasSuccessful` | Report whether or not this test suite was successful or not.
Class Variable | `__test__` | Undocumented
Class Variable | `errors` | Undocumented
Instance Variable | `expectedFailures` | Undocumented
Instance Variable | `skips` | Undocumented
Instance Variable | `successes` | count the number of successes achieved by the test run.
Instance Variable | `unexpectedSuccesses` | Undocumented
Method | `_getFailure` | Convert a `sys.exc_info()`-style tuple to a `Failure`, if necessary.
Method | `_getTime` | Undocumented
Constant | `_DEFAULT_TODO` | Undocumented
Instance Variable | `_lastTime` | The duration of the current test run. It defaults to `None`, which means that the test was skipped.
Instance Variable | `_testStarted` | Undocumented
Instance Variable | `_timings` | Undocumented

def __init__(self, stream=sys.stdout, *args, **kwargs): (source)
overrides `twisted.trial.reporter.Reporter.__init__`

Undocumented

def addError(self, *args): (source)
from `twisted.trial.itrial.IReporter`
overrides `twisted.trial.reporter.Reporter.addError`

Called when a test raises an error. If `realtime` is set, then it prints the error to the stream.

Parameters
*args | Undocumented
test | `ITestCase` that raised the error.
error | `failure.Failure` containing the error.

def addExpectedFailure(self, *args): (source)
from `twisted.trial.itrial.IReporter`
overrides `twisted.trial.reporter.TestResult.addExpectedFailure`

Report that the given test failed, and was expected to do so.

In Trial, tests can be marked 'todo'. That is, they are expected to fail.

Parameters
*args | Undocumented
test:`pyunit.TestCase` | Undocumented
error:`Failure` | Undocumented
todo:`unittest.Todo`, or `None`, in which case a default todo message is provided. | Undocumented

def addFailure(self, *args): (source)
from `twisted.trial.itrial.IReporter`
overrides `twisted.trial.reporter.Reporter.addFailure`

Called when a test fails. If `realtime` is set, then it prints the error to the stream.

Parameters
*args | Undocumented
test | `ITestCase` that failed.
fail | `failure.Failure` containing the error.

def addSkip(self, *args): (source)
from `twisted.trial.itrial.IReporter`
overrides `twisted.trial.reporter.TestResult.addSkip`

Report that the given test was skipped.

In Trial, tests can be 'skipped'. Tests are skipped mostly because there is some platform or configuration issue that prevents them from being run correctly.

Parameters
*args | Undocumented
test:`pyunit.TestCase` | Undocumented
reason:`str` | Undocumented

def addSuccess(self, test): (source)
from `twisted.trial.itrial.IReporter`
overrides `twisted.trial.reporter.TestResult.addSuccess`

Report that the given test succeeded.

Parameters
test:`pyunit.TestCase` | Undocumented

def addUnexpectedSuccess(self, *args): (source)
from `twisted.trial.itrial.IReporter`
overrides `twisted.trial.reporter.TestResult.addUnexpectedSuccess`

Report that the given test succeeded against expectations.

In Trial, tests can be marked 'todo'. That is, they are expected to fail. When a test that is expected to fail instead succeeds, it should call this method to report the unexpected success.

Parameters
*args | Undocumented
test:`pyunit.TestCase` | Undocumented
todo:`unittest.Todo`, or `None`, in which case a default todo message is provided. | Undocumented

def cleanupErrors(self, errs): (source)
overrides `twisted.trial.reporter.Reporter.cleanupErrors`

Undocumented

def endLine(self, message, color): (source)

Print 'message' in the given color.

Parameters
message | A string message, usually '[OK]' or something similar.
color | A string color, 'red', 'green' and so forth.

def getDescription(self, test): (source)

Return the name of the method which 'test' represents. This is what gets displayed in the leaves of the tree.

e.g. getDescription(TestCase('test_foo')) ==> test_foo

def startTest(self, test): (source)
from `twisted.trial.itrial.IReporter`
overrides `twisted.trial.reporter.Reporter.startTest`

Called when `test` starts. Writes the tests name to the stream using a tree format.

def upDownError(self, method, error, warn, printStatus): (source)
overrides `twisted.trial.reporter.Reporter.upDownError`

Undocumented

ERROR: `str` = (source)

Undocumented

Value

    'red'

FAILURE: `str` = (source)

Undocumented

Value

    'red'

SKIP: `str` = (source)

Undocumented

Value

    'blue'

SUCCESS: `str` = (source)

Undocumented

Value

    'green'

TODO: `str` = (source)

Undocumented

Value

    'blue'

TODONE: `str` = (source)

Undocumented

Value

    'red'

columns: `int` = (source)

Undocumented

indent: `str` = (source)

Undocumented

currentLine = (source)

Undocumented

def _getPreludeSegments(self, testID): (source)

Return a list of all non-leaf segments to display in the tree.

Normally this is the module and class name.

def _printSummary(self): (source)
overrides `twisted.trial.reporter.Reporter._printSummary`

Print a line summarising the test results to the stream, and color the status result.

def _testPrelude(self, testID): (source)

Write the name of the test to the stream, indenting it appropriately.

If the test is the first test in a new 'branch' of the tree, also write all of the parents in that branch.

def _write(self, format, *args): (source)
overrides `twisted.trial.reporter.Reporter._write`

Safely write to the reporter's stream.

Parameters
format | A format string to write.
*args | The arguments for the format string.

_colorizer = (source)

Undocumented

_lastTest = (source)

Undocumented